VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form FormWaveEx 
   Caption         =   "Wave Exposure model - MT Burrows SAMS 2007"
   ClientHeight    =   7545
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   7845
   LinkTopic       =   "Form1"
   ScaleHeight     =   7545
   ScaleWidth      =   7845
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.ProgressBar ProgressBar1 
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   3240
      Visible         =   0   'False
      Width           =   1815
      _ExtentX        =   3201
      _ExtentY        =   450
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.TextBox TextDispersalRange 
      Height          =   285
      Left            =   1440
      TabIndex        =   8
      Text            =   "50"
      Top             =   2760
      Width           =   495
   End
   Begin VB.PictureBox PictureMap 
      AutoRedraw      =   -1  'True
      Height          =   7455
      Left            =   2040
      ScaleHeight     =   7395
      ScaleWidth      =   5595
      TabIndex        =   0
      Top             =   0
      Width           =   5655
   End
   Begin MSComDlg.CommonDialog CMDialog1 
      Left            =   120
      Top             =   3720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label LabelCol 
      Caption         =   "Col"
      Height          =   255
      Left            =   840
      TabIndex        =   12
      Top             =   4320
      Width           =   615
   End
   Begin VB.Label LabelRow 
      Caption         =   "Row"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   4320
      Width           =   615
   End
   Begin VB.Label LabelDispersalRange 
      Caption         =   "Maximum Range"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   1335
   End
   Begin VB.Label LabelNCols 
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   1815
   End
   Begin VB.Label LabelNRows 
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1200
      Width           =   1815
   End
   Begin VB.Label LabelYllcorner 
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2400
      Width           =   1815
   End
   Begin VB.Label LabelXllcorner 
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2040
      Width           =   1815
   End
   Begin VB.Label LabelCellSize 
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1455
   End
   Begin VB.Label LabelStat1 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   1815
   End
   Begin VB.Label LabelProgress 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   1815
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileLoadMap 
         Caption         =   "Load &Map"
         Shortcut        =   ^M
      End
      Begin VB.Menu mnuFileSaveTGrid 
         Caption         =   "Save Fetch Data as &Grid"
      End
      Begin VB.Menu mnuFileSaveFetch 
         Caption         =   "Save Fetch Data as XYZ to &File"
      End
      Begin VB.Menu mnuFileSaveMapSubset 
         Caption         =   "Save Map Subse&t"
      End
      Begin VB.Menu mnuFileSaveCoastSubset 
         Caption         =   "Save &Coast Subset"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnusim 
      Caption         =   "&Calculate"
      Begin VB.Menu mnusimFetch 
         Caption         =   "&Fetch"
      End
      Begin VB.Menu mnuSimStop 
         Caption         =   "&Stop"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSimClearCoast 
         Caption         =   "&Clear Coast"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuSimRedrawMap 
         Caption         =   "&Redraw Map"
      End
   End
End
Attribute VB_Name = "FormWaveEx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Wave Fetch Model for determination of wave fetch on coastal grids
'    Copyright (C) 2007, Mike Burrows, SAMS
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.


Dim WindDir(16), PnTime(16), MeanVel(16), WindEnergy(16)

Dim LandValue As Integer
Dim CoastValue As Integer

Dim HabitatMap() As Integer
Dim WaveExMap() As Single
Dim CoastCellMap() As Long

Dim MaxDistance&

Dim CoastCell(150000, 20), CoastCellCount&
Dim IndFetch(20)

Dim ncols, nrows As Integer
Dim xllcorner, yllcorner
Dim NODATA
Dim cellsize

Dim SimStopFlag As Integer
Dim SimStopManyFlag As Integer
Dim SeedFlag, SeedLocX, SeedLocY As Integer
Dim StartCell&

Private Sub Form_Load()
   SeedFlag = False
   Dummy = MsgBox("Wave Fetch Model for determination of wave fetch on coastal grids " & Chr(13) & Chr(10) & Chr(13) & Chr(10) _
    & " Copyright (C) 2007, Mike Burrows, SAMS " & Chr(13) & Chr(10) & Chr(13) & Chr(10) _
    & " This program is free software: you can redistribute it and/or modify " & Chr(13) & Chr(10) _
    & " it under the terms of the GNU General Public License as published by" & Chr(13) & Chr(10) _
    & " the Free Software Foundation, either version 3 of the License, or" & Chr(13) & Chr(10) _
    & " any later version." & Chr(13) & Chr(10) & Chr(13) & Chr(10) _
    & " This program is distributed in the hope that it will be useful," & Chr(13) & Chr(10) _
    & " but WITHOUT ANY WARRANTY; without even the implied warranty of" & Chr(13) & Chr(10) _
    & " MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the" & Chr(13) & Chr(10) _
    & " GNU General Public License for more details." & Chr(13) & Chr(10) _
    & " You should have received a copy of the GNU General Public License" & Chr(13) & Chr(10) _
    & " along with this program.  If not, see <http://www.gnu.org/licenses/>.", , "Disclaimer")
   
End Sub

Private Sub mnuFileSaveFetch_Click()
   Dim OSEast As Double
   Dim OSNorth As Double
   
   On CMDialog1.CancelError = True GoTo Errlin21
   ' Set Filters.
   CMDialog1.Filter = "All Files (*.*)|*.*|Data Files (*.dat)|*.dat"
   ' Specify default filter
   CMDialog1.FilterIndex = 2
   'Dislay the Open Dialog Box
   CMDialog1.DialogTitle = "Save Fetch file as"
   CMDialog1.FileName = "Fetch.dat"
   CMDialog1.Action = 2
   ' Open the Save File Procedure

' Saving file data
   
   Open CMDialog1.FileName For Output As #1
   Print #1, "CellNo,OSEast,OSNorth,Col,Row,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,fetchsum,f3avg"
   ProgressBar1.Max = CoastCellCount&
   For k& = 1 To CoastCellCount&
      ProgressBar1.Value = k&
      OSEast = cellsize * 0.5 + (xllcorner + cellsize * (CoastCell(k&, 1)))
      OSNorth = cellsize * 0.5 + (yllcorner + cellsize * (CoastCell(k&, 2)))
'      LatOS = GPSfromOS("Lat", OSEast, OSNorth)
'      LongOS = GPSfromOS("Long", OSEast, OSNorth)
      Print #1, Format(k&, "0"); ","; Format(OSEast, "0"); ","; Format(OSNorth, "0"); _
            ","; ' Format(LatOS, "0.00000000"); ","; Format(LongOS, "0.00000000");
      For l& = 1 To 20
      Print #1, ","; Format(CoastCell(k&, l&), "0.0");
      Next l&
      Print #1,
   Next k&

Errlin21:
   Close #1

End Sub

Private Sub mnuFileSaveMapSubset_Click()

' Needs a map already loaded

   Response = MsgBox("Values in m ?", vbYesNo, "Output Style")
   If Response = vbYes Then
' if input is in map units
     nxllcorner = Val(InputBox("Input Box Coordinates", "Lower Left X", xllcorner))
     nxurcorner = Val(InputBox("Input Box Coordinates", "Upper Right X", xllcorner + ncols))
     nyllcorner = Val(InputBox("Input Box Coordinates", "Lower Left Y", yllcorner))
     nyurcorner = Val(InputBox("Input Box Coordinates", "Upper Right Y", yllcorner + nrows))
     nncols = 1 + Int(nxurcorner - nxllcorner) / cellsize
     nnrows = Int(nyurcorner - nyllcorner) / cellsize
     xurnew = 1 + (nxurcorner - xllcorner) / cellsize
     xllnew = 1 + (nxllcorner - xllcorner) / cellsize
     yurnew = (nyurcorner - yllcorner) / cellsize
     yllnew = (nyllcorner - yllcorner) / cellsize

   Else
     xllnew = Val(InputBox("Input Box Coordinates", "Lower Left X", 1))
     xurnew = Val(InputBox("Input Box Coordinates", "Upper Right X", ncols))
     yllnew = Val(InputBox("Input Box Coordinates", "Lower Left Y", 1))
     yurnew = Val(InputBox("Input Box Coordinates", "Upper Right Y", nrows))
   End If

   On CMDialog1.CancelError = True GoTo ErrLin201
   ' Set Filters.
   CMDialog1.Filter = "All Files (*.*)|*.*|ArcView Export Files (*.asc)|*.asc|Data Files (*.dat)|*.dat"
   ' Specify default filter
   CMDialog1.FilterIndex = 2
   'Dislay the Open Dialog Box
   CMDialog1.DialogTitle = "Save Map Subset as"
   CMDialog1.FileName = "Subset.asc"
   CMDialog1.Action = 2
   ' Open the Save File Procedure

' Saving file data
   
   Open CMDialog1.FileName For Output As #1
   ' Open the Save File Procedure
   
   If Response = vbYes Then
     Print #1, "ncols         "; xurnew - xllnew + 1
     Print #1, "nrows         "; yurnew - yllnew
     Print #1, "xllcorner     "; nxllcorner
     Print #1, "yllcorner     "; nyllcorner
   Else
     Print #1, "ncols         "; xurnew - xllnew + 1
     Print #1, "nrows         "; yurnew - yllnew
     Print #1, "xllcorner     "; xllcorner + (cellsize * (xllnew - 1))
     Print #1, "yllcorner     "; yllcorner + (cellsize * yllnew)
   End If
   Print #1, "cellsize      "; cellsize
   Print #1, "NODATA_value  0"
   

   ProgressBar1.Min = 0
   ProgressBar1.Max = nrows

' Writing space delimited grid data
   ProgressBar1.Visible = True
  
  Stepk& = 1
  If Response = vbYes Then
  Stepk& = -1
   For k& = yurnew To yllnew Step Stepk&
    For j& = xllnew To xurnew
       Print #1, Format(HabitatMap(j&, k&), "0");
       Print #1, " ";
     Next j&
     Print #1,
   Next k&
   Else
   Stepk& = -1
   For k& = yurnew To yllnew Step Stepk&
    For j& = xllnew To xurnew
       Print #1, Format(HabitatMap(j&, k&), "0");
       Print #1, " ";
     Next j&
     Print #1,
   Next k&

   End If

ErrLin201:
  Close #1

MsgBox ("Done")
ProgressBar1.Visible = False
End Sub

Private Sub mnuFileSaveTGrid_Click()

   On CMDialog1.CancelError = True GoTo ErrLin20
   ' Set Filters.
   CMDialog1.Filter = "All Files (*.*)|*.*|ArcView Export Files (*.asc)|*.asc|Data Files (*.dat)|*.dat"
   ' Specify default filter
   CMDialog1.FilterIndex = 2
   'Dislay the Open Dialog Box
   CMDialog1.DialogTitle = "Save Wave exposure file as"
   CMDialog1.FileName = "WaveEx.asc"
   CMDialog1.Action = 2
   ' Open the Save File Procedure

' Saving file data
   
   Open CMDialog1.FileName For Output As #1
   
   ' Open the Save File Procedure
   Print #1, "ncols         "; ncols
   Print #1, "nrows         "; nrows
   Print #1, "xllcorner     "; xllcorner
   Print #1, "yllcorner     "; yllcorner
   Print #1, "cellsize      "; cellsize
   Print #1, "NODATA_value  0"
      
   ProgressBar1.Min = 0
   ProgressBar1.Max = nrows

' Writing space delimited grid data
   ProgressBar1.Visible = True

   For k& = nrows - 1 To 0 Step -1
    For j& = 0 To ncols - 1
       If WaveExMap(j&, k&) > 0 Then
       Print #1, Format(WaveExMap(j&, k&), "0.00");
       Else
       Print #1, "0";
       End If
       Print #1, " ";
     Next j&
     Print #1,

     ProgressBar1.Value = k&
   Next k&

ErrLin20:
  Close #1

MsgBox ("Done")
ProgressBar1.Visible = False
End Sub
Private Sub mnuFileExit_Click()
  End
End Sub

Private Sub mnuFileLoadMap_Click()
   ' CancelError is True.
   On CMDialog1.CancelError = True GoTo ErrLin1
   ' Set Filters.
   CMDialog1.Filter = "All Files (*.*)|*.*|ArcView Export Files (*.asc)|*.asc|Data Files (*.dat)|*.dat"
   ' Specify default filter
   CMDialog1.FilterIndex = 2
   'Dislay the Open Dialog Box
   CMDialog1.Action = 1
   
   ' Open the Open File Procedure

' Loading file data
   
   Open CMDialog1.FileName For Input As #1

LabelProgress.Caption = "Loading land ...."
   
   LandValue = 1
   CoastValue = 2
  
   Input #1, inline$
   ncols = Val(Mid$(inline$, 15))
   Input #1, inline$
   nrows = Val(Mid$(inline$, 15))
   Input #1, inline$
   xllcorner = Val(Mid$(inline$, 15))
   Input #1, inline$
   yllcorner = Val(Mid$(inline$, 15))
   Input #1, inline$
   cellsize = Val(Mid$(inline$, 15))
   Input #1, inline$
   NODATA = Val(Mid$(inline$, 15))
   LabelYllcorner.Caption = "yllcorner: " & Format(yllcorner, 0) & "m"
   LabelXllcorner.Caption = "xllcorner: " & Format(xllcorner, 0) & "m"
   LabelCellSize.Caption = "cellsize: " & cellsize & "m"
   LabelNRows.Caption = "nrows: " & nrows & "   (" & nrows * cellsize / 1000 & "km)"
   LabelNCols.Caption = "ncols: " & ncols & "   (" & ncols * cellsize / 1000 & "km)"

   ReDim HabitatMap(ncols + 1, nrows + 1)
   ReDim CoastCellMap(ncols + 1, nrows + 1)
    
   ProgressBar1.Min = 0
   ProgressBar1.Max = nrows

   PictureMap.ScaleHeight = nrows
   PictureMap.Width = ncols * (PictureMap.Height / PictureMap.ScaleHeight)
   PictureMap.ScaleWidth = ncols
   FormWaveEx.Width = PictureMap.Left + PictureMap.Width + 200

' Reading space delimited grid data
   ProgressBar1.Visible = True
   FormWaveEx.Refresh

   For i& = nrows - 1 To 0 Step -1
     ProgressBar1.Value = i&
     Input #1, inline$
     k& = 1
     For j& = 0 To ncols - 2 ' 2
       IsSpace$ = ""
       l& = 0
       Do Until IsSpace$ = " "
         IsSpace$ = Mid$(inline$, k& + l&, 1)
         l& = l& + 1
       Loop
       HabitatMap(j&, i&) = Val(Mid$(inline$, k&, l& - 1))
       k& = k& + l&
       
       If HabitatMap(j&, i&) = LandValue Then
         PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(9), BF
       End If

     Next j&
     HabitatMap(ncols - 1, i&) = Val(Mid$(inline$, k&, Len(inline$) - k& + 1))
     PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(9), BF
  Next i&
ErrLin1:
Close #1
ProgressBar1.Visible = False
'LoadCoast
GenerateCoast
End Sub
Private Sub GenerateCoast()
LabelProgress.Caption = "Generating Coast ...."
ProgressBar1.Visible = True
CoastCellCount& = 0
   FormWaveEx.Refresh
   For i& = 0 To nrows - 1
      ProgressBar1.Value = i&
      For j& = 0 To ncols - 1
        CoastFlag& = False
        Select Case HabitatMap(j&, i&)
        Case LandValue
          For jshift& = -1 To 1
          For ishift& = -1 To 1
          If Not (j& + jshift& < 0 Or i& + ishift& < 0 Or j& + jshift& > ncols - 1 Or i& + ishift& > nrows) Then
' Coast only if not diagonally adjacent
            If Not (Abs(jshift&) + Abs(ishift&) > 1) Then
' For simple grids (Land=1 Sea=0)
'            If HabitatMap(j& + jshift&, i& + ishift&) = 0 Then CoastFlag& = True
' For Grids zoned with distance to coast (Land=1, <5km=10, 5-10km=11, 10-20km=12, >20km=13)
              If HabitatMap(j& + jshift&, i& + ishift&) <> LandValue _
                 And HabitatMap(j& + jshift&, i& + ishift&) <> CoastValue Then CoastFlag& = True
' end if not diagonally adjacent
            End If
          End If
      
          
          Next ishift&
          Next jshift&
        Case CoastValue
          CoastFlag& = True
        End Select
        If CoastFlag& = True Then
             CoastCellCount& = CoastCellCount& + 1
             HabitatMap(j&, i&) = CoastValue
             PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(10), BF
             CoastCell(CoastCellCount&, 1) = j&
             CoastCell(CoastCellCount&, 2) = i&
             CoastCell(CoastCellCount&, 3) = 0
             CoastCellMap(j&, i&) = CoastCellCount&
        End If
      Next j&
  Next i&
  LabelProgress.Caption = ""
  ProgressBar1.Visible = False
End Sub
Private Sub ClearCoast()
   For k& = 1 To CoastCellCount&
      j& = CoastCell(k&, 1)
      i& = CoastCell(k&, 2)
      CoastCell(k&, 3) = 0
      PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(10), BF
   Next k&
End Sub

Private Sub RedrawMap()
   LabelProgress.Caption = "Redrawing Map ...."
   ProgressBar1.Visible = True
   ProgressBar1.Max = nrows
   FormWaveEx.Refresh
   PictureMap.Cls
   For i& = 1 To nrows
      ProgressBar1.Value = i&
      For j& = 1 To ncols
         Select Case HabitatMap(j&, i&)
'        Case 0                                                        No Colour - Sea
         Case CoastValue
            PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(10), BF 'Green: Coast
         Case LandValue
            PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), QBColor(9), BF  'Blue: Land
         End Select
      Next j&
   Next i&
   LabelProgress.Caption = ""
   ProgressBar1.Visible = False
End Sub

Private Sub mnuSimClearCoast_Click()
   ClearCoast
End Sub

Private Sub mnusimFetch_Click()
   CalculateFetch
End Sub

Private Sub mnuSimRedrawMap_Click()
   RedrawMap
End Sub

Private Sub CalculateFetch()
   ReDim WaveExMap(ncols + 1, nrows + 1)
   MaxDistance& = Val(TextDispersalRange.Text)
   MinFetch = 16 * MaxDistance&
   MaxFetch = 0
   ProgressBar1.Visible = True
   ProgressBar1.Max = CoastCellCount&
   For k& = 1 To CoastCellCount&
      Dummy = DoEvents
      ProgressBar1.Value = k&
       j& = CoastCell(k&, 1)
       i& = CoastCell(k&, 2)
       MinX& = -MaxDistance&
       MaxX& = MaxDistance&
       MinY& = -MaxDistance&
       MaxY& = MaxDistance&
       If j& + MinX& < 0 Then MinX& = -j&
       If j& + MaxX& > ncols Then MaxX& = ncols - j&
       If i& + MinY& < 0 Then MinY& = -i&
       If i& + MaxY& > nrows Then MaxY& = nrows - i&
       
       For l& = 1 To 16
         CoastCell(k&, 2 + l&) = MaxDistance&
       Next l&
       
       For jshift& = MinX& To MaxX& Step 100
         For ishift& = MinY& To MaxY& Step 100
          IsItCoast k&, i&, j&, ishift&, jshift&
          Next ishift&
       Next jshift&
       
       For jshift& = 0.1 * MinX& To 0.1 * MaxX& Step 10
         For ishift& = 0.1 * MinY& To 0.1 * MaxY& Step 10
          IsItCoast k&, i&, j&, ishift&, jshift&
          Next ishift&
       Next jshift&
             
       For jshift& = -10 To 10 Step 1
         For ishift& = -10 To 10 Step 1
          IsItCoast k&, i&, j&, ishift&, jshift&
          Next ishift&
       Next jshift&

       SumFetch = 0
       
       For l& = 1 To 16
         SumFetch = SumFetch + CoastCell(k&, 2 + l&)
       Next l&
       If SumFetch < MinFetch Then MinFetch = SumFetch
       If SumFetch > MaxFetch Then MaxFetch = SumFetch
       
       FetchCol = 255 * SumFetch / 800
       PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), RGB(FetchCol, 0, 0), BF
       FormWaveEx.Refresh
       CoastCell(k&, 19) = SumFetch  ' Summed Fetch values
       WaveExMap(j&, i&) = SumFetch
   Next k&
   
   For k& = 1 To CoastCellCount&
      ProgressBar1.Value = k&
      j& = CoastCell(k&, 1)
      i& = CoastCell(k&, 2)
      FetchCol = 255 * (CoastCell(k&, 19) - MinFetch) / MaxFetch
      PictureMap.Line (j&, (1 + nrows - i&))-(j& + 1, nrows - i&), RGB(FetchCol, FetchCol, 0), BF
' Calculate 3-cell neighbourhood avgs
      SumSumFetch = 0
      NNeighbourCells = 0
      For jshift& = -1 To 1 Step 1
         For ishift& = -1 To 1 Step 1
            If Not (i& + ishift& > nrows Or i& + ishift& < 0 Or j& + jshift& > ncols Or j& + jshift& < 0) Then
              If CoastCellMap(j& + jshift&, i& + ishift&) > 0 Then
                 SumSumFetch = SumSumFetch + CoastCell(CoastCellMap(j& + jshift&, i& + ishift&), 19)
                 NNeighbourCells = NNeighbourCells + 1
              End If
            End If
         Next ishift&
      Next jshift&
      CoastCell(k&, 20) = SumSumFetch / NNeighbourCells
   Next k&

End Sub


Private Sub IsItCoast(k&, i&, j&, ishift&, jshift&)
  If Not (i& + ishift& > nrows Or i& + ishift& < 0 Or j& + jshift& > ncols Or j& + jshift& < 0) Then
      If Not (jshift& = 0 And ishift& = 0) Then
          DistPoint = Distance(j&, i&, j& + jshift&, i& + ishift&)
          If k& = 1000 * Int(k& / 1000) Then
            PictureMap.PSet ((j& + jshift&), 1 + nrows - (i& + ishift&)), QBColor(8)
          End If
          SAngle = Angle(j&, i&, j& + jshift&, i& + ishift&)
          SectorAngle = Int(5.5 + 16 * (SAngle / (2 * 3.14159265358979)))
      
          If SectorAngle > 16 Then SectorAngle = SectorAngle - 16
'    Land Cells more than 1 cell away
          If (HabitatMap(j& + jshift&, i& + ishift&) = LandValue Or HabitatMap(j& + jshift&, i& + ishift&) = CoastValue) And CoastCell(k&, 2 + SectorAngle) > DistPoint _
             Then
             CoastCell(k&, 2 + SectorAngle) = DistPoint
          End If
'    If the cell is adjacent make distance to cell zero along three adjacent sectors
'    All adjacent cells
          If (HabitatMap(j& + jshift&, i& + ishift&) = LandValue Or HabitatMap(j& + jshift&, i& + ishift&) = CoastValue) And ((Abs(jshift&) = 1 Or Abs(jshift&) = 0) And (Abs(ishift&) = 0 Or Abs(ishift&) = 1)) Then _
              CoastCell(k&, 2 + SectorAngle) = 0
'    Diagonal cells only
          If (HabitatMap(j& + jshift&, i& + ishift&) = LandValue Or HabitatMap(j& + jshift&, i& + ishift&) = CoastValue) And ((Abs(jshift&) = 1 And Abs(ishift&) = 1)) Then
            For m& = -1 To 1
              SectorN = SectorAngle + m&
              If SectorN > 16 Then SectorN = SectorN - 16
              If SectorN < 1 Then SectorN = SectorN + 16
              CoastCell(k&, 2 + SectorN) = 0
            Next m&
          End If
      End If
  End If
End Sub


Private Function Angle(x1, y1, x2, y2)
  If (x2 - x1) <> 0 And (y2 - y1) <> 0 Then
    Theta = Atn((x2 - x1) / (y2 - y1))
    If (y2 - y1) < 0 Then Theta = Theta + 3.141593
  End If
  
  If (y2 - y1) = 0 Then
    If (x2 - x1) < 0 Then
    Theta = -3.141593 / 2
    Else
    Theta = 3.141593 / 2
    End If
  End If
  
  If (x2 - x1) = 0 Then
    If (y2 - y1) < 0 Then
    Theta = 3.141593
    Else
    Theta = 0
    End If
  End If
    
  Angle = Theta

End Function
Private Function Distance(x1, y1, x2, y2)
   Distance = Sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
End Function

Private Sub PictureMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   If nrows > 0 Then LabelRow.Caption = Int(nrows - Y) Else LabelRow.Caption = Int(Y)
   LabelCol.Caption = Int(X)
End Sub


